unit schReferenciasServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, FmtBCD, uROXMLIntf, schReferenciasClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_ReferenciasDelta = '{3D76ED26-23CC-4938-82C0-6044A5F5284F}';

type
  { IReferenciasDelta }
  IReferenciasDelta = interface(IReferencias)
  ['{3D76ED26-23CC-4938-82C0-6044A5F5284F}']
    { Property getters and setters }
    function GetOldIDValue : Integer;
    function GetOldID_EMPRESAValue : Integer;
    function GetOldID_TIENDAValue : Integer;
    function GetOldCODIGOValue : String;
    function GetOldVALORValue : String;
    function GetOldDESCRIPCIONValue : String;

    { Properties }
    property OldID : Integer read GetOldIDValue;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldID_TIENDA : Integer read GetOldID_TIENDAValue;
    property OldCODIGO : String read GetOldCODIGOValue;
    property OldVALOR : String read GetOldVALORValue;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
  end;

  { TReferenciasBusinessProcessorRules }
  TReferenciasBusinessProcessorRules = class(TDABusinessProcessorRules, IReferencias, IReferenciasDelta)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    function GetIDIsNull: Boolean; virtual;
    function GetOldIDValue: Integer; virtual;
    function GetOldIDIsNull: Boolean; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    function GetOldID_EMPRESAValue: Integer; virtual;
    function GetOldID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetID_TIENDAValue: Integer; virtual;
    function GetID_TIENDAIsNull: Boolean; virtual;
    function GetOldID_TIENDAValue: Integer; virtual;
    function GetOldID_TIENDAIsNull: Boolean; virtual;
    procedure SetID_TIENDAValue(const aValue: Integer); virtual;
    procedure SetID_TIENDAIsNull(const aValue: Boolean); virtual;
    function GetCODIGOValue: String; virtual;
    function GetCODIGOIsNull: Boolean; virtual;
    function GetOldCODIGOValue: String; virtual;
    function GetOldCODIGOIsNull: Boolean; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    procedure SetCODIGOIsNull(const aValue: Boolean); virtual;
    function GetVALORValue: String; virtual;
    function GetVALORIsNull: Boolean; virtual;
    function GetOldVALORValue: String; virtual;
    function GetOldVALORIsNull: Boolean; virtual;
    procedure SetVALORValue(const aValue: String); virtual;
    procedure SetVALORIsNull(const aValue: Boolean); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    function GetDESCRIPCIONIsNull: Boolean; virtual;
    function GetOldDESCRIPCIONValue: String; virtual;
    function GetOldDESCRIPCIONIsNull: Boolean; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID : Integer read GetIDValue write SetIDValue;
    property IDIsNull : Boolean read GetIDIsNull write SetIDIsNull;
    property OldID : Integer read GetOldIDValue;
    property OldIDIsNull : Boolean read GetOldIDIsNull;
    property ID_EMPRESA : Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull : Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property OldID_EMPRESA : Integer read GetOldID_EMPRESAValue;
    property OldID_EMPRESAIsNull : Boolean read GetOldID_EMPRESAIsNull;
    property ID_TIENDA : Integer read GetID_TIENDAValue write SetID_TIENDAValue;
    property ID_TIENDAIsNull : Boolean read GetID_TIENDAIsNull write SetID_TIENDAIsNull;
    property OldID_TIENDA : Integer read GetOldID_TIENDAValue;
    property OldID_TIENDAIsNull : Boolean read GetOldID_TIENDAIsNull;
    property CODIGO : String read GetCODIGOValue write SetCODIGOValue;
    property CODIGOIsNull : Boolean read GetCODIGOIsNull write SetCODIGOIsNull;
    property OldCODIGO : String read GetOldCODIGOValue;
    property OldCODIGOIsNull : Boolean read GetOldCODIGOIsNull;
    property VALOR : String read GetVALORValue write SetVALORValue;
    property VALORIsNull : Boolean read GetVALORIsNull write SetVALORIsNull;
    property OldVALOR : String read GetOldVALORValue;
    property OldVALORIsNull : Boolean read GetOldVALORIsNull;
    property DESCRIPCION : String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull : Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property OldDESCRIPCION : String read GetOldDESCRIPCIONValue;
    property OldDESCRIPCIONIsNull : Boolean read GetOldDESCRIPCIONIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers, uDAInterfaces;

{ TReferenciasBusinessProcessorRules }
constructor TReferenciasBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TReferenciasBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TReferenciasBusinessProcessorRules.GetIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID];
end;

function TReferenciasBusinessProcessorRules.GetIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID]);
end;

function TReferenciasBusinessProcessorRules.GetOldIDValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasID];
end;

function TReferenciasBusinessProcessorRules.GetOldIDIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasID]);
end;

procedure TReferenciasBusinessProcessorRules.SetIDValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID] := aValue;
end;

procedure TReferenciasBusinessProcessorRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID] := Null;
end;

function TReferenciasBusinessProcessorRules.GetID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID_EMPRESA];
end;

function TReferenciasBusinessProcessorRules.GetID_EMPRESAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID_EMPRESA]);
end;

function TReferenciasBusinessProcessorRules.GetOldID_EMPRESAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasID_EMPRESA];
end;

function TReferenciasBusinessProcessorRules.GetOldID_EMPRESAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasID_EMPRESA]);
end;

procedure TReferenciasBusinessProcessorRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID_EMPRESA] := aValue;
end;

procedure TReferenciasBusinessProcessorRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID_EMPRESA] := Null;
end;

function TReferenciasBusinessProcessorRules.GetID_TIENDAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID_TIENDA];
end;

function TReferenciasBusinessProcessorRules.GetID_TIENDAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID_TIENDA]);
end;

function TReferenciasBusinessProcessorRules.GetOldID_TIENDAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasID_TIENDA];
end;

function TReferenciasBusinessProcessorRules.GetOldID_TIENDAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasID_TIENDA]);
end;

procedure TReferenciasBusinessProcessorRules.SetID_TIENDAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID_TIENDA] := aValue;
end;

procedure TReferenciasBusinessProcessorRules.SetID_TIENDAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasID_TIENDA] := Null;
end;

function TReferenciasBusinessProcessorRules.GetCODIGOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasCODIGO];
end;

function TReferenciasBusinessProcessorRules.GetCODIGOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasCODIGO]);
end;

function TReferenciasBusinessProcessorRules.GetOldCODIGOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasCODIGO];
end;

function TReferenciasBusinessProcessorRules.GetOldCODIGOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasCODIGO]);
end;

procedure TReferenciasBusinessProcessorRules.SetCODIGOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasCODIGO] := aValue;
end;

procedure TReferenciasBusinessProcessorRules.SetCODIGOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasCODIGO] := Null;
end;

function TReferenciasBusinessProcessorRules.GetVALORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasVALOR];
end;

function TReferenciasBusinessProcessorRules.GetVALORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasVALOR]);
end;

function TReferenciasBusinessProcessorRules.GetOldVALORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasVALOR];
end;

function TReferenciasBusinessProcessorRules.GetOldVALORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasVALOR]);
end;

procedure TReferenciasBusinessProcessorRules.SetVALORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasVALOR] := aValue;
end;

procedure TReferenciasBusinessProcessorRules.SetVALORIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasVALOR] := Null;
end;

function TReferenciasBusinessProcessorRules.GetDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasDESCRIPCION];
end;

function TReferenciasBusinessProcessorRules.GetDESCRIPCIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasDESCRIPCION]);
end;

function TReferenciasBusinessProcessorRules.GetOldDESCRIPCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasDESCRIPCION];
end;

function TReferenciasBusinessProcessorRules.GetOldDESCRIPCIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_ReferenciasDESCRIPCION]);
end;

procedure TReferenciasBusinessProcessorRules.SetDESCRIPCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasDESCRIPCION] := aValue;
end;

procedure TReferenciasBusinessProcessorRules.SetDESCRIPCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_ReferenciasDESCRIPCION] := Null;
end;


initialization
  RegisterBusinessProcessorRules(RID_ReferenciasDelta, TReferenciasBusinessProcessorRules);

end.
